using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using Phoner;

namespace Dialer
{
	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class Dialer : Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		Phoner.CPhoner myPhoner = new Phoner.CPhonerClass();
		int CurrCallID = 0;
		int AcceptID = 0;
		private System.Windows.Forms.Button btnConnect;
		private System.Windows.Forms.Button btnDisconnect;
		private System.Windows.Forms.TextBox number;
		private System.Windows.Forms.Label lblNumber;
		private System.Windows.Forms.RichTextBox result;

		public Dialer()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			myPhoner.OnChangeState +=new ICPhonerEvents_OnChangeStateEventHandler(myPhoner_OnChangeState);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnConnect = new System.Windows.Forms.Button();
			this.btnDisconnect = new System.Windows.Forms.Button();
			this.number = new System.Windows.Forms.TextBox();
			this.lblNumber = new System.Windows.Forms.Label();
			this.result = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// btnConnect
			// 
			this.btnConnect.Location = new System.Drawing.Point(16, 232);
			this.btnConnect.Name = "btnConnect";
			this.btnConnect.TabIndex = 2;
			this.btnConnect.Text = "Connect";
			this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
			// 
			// btnDisconnect
			// 
			this.btnDisconnect.Location = new System.Drawing.Point(112, 232);
			this.btnDisconnect.Name = "btnDisconnect";
			this.btnDisconnect.TabIndex = 3;
			this.btnDisconnect.Text = "Disconnect";
			this.btnDisconnect.Click += new System.EventHandler(this.btnDisconnect_Click);
			// 
			// number
			// 
			this.number.Location = new System.Drawing.Point(104, 24);
			this.number.Name = "number";
			this.number.Size = new System.Drawing.Size(224, 20);
			this.number.TabIndex = 4;
			this.number.Text = "";
			// 
			// lblNumber
			// 
			this.lblNumber.Location = new System.Drawing.Point(16, 24);
			this.lblNumber.Name = "lblNumber";
			this.lblNumber.Size = new System.Drawing.Size(80, 16);
			this.lblNumber.TabIndex = 5;
			this.lblNumber.Text = "Number";
			// 
			// result
			// 
			this.result.Location = new System.Drawing.Point(16, 56);
			this.result.Name = "result";
			this.result.ReadOnly = true;
			this.result.Size = new System.Drawing.Size(592, 168);
			this.result.TabIndex = 6;
			this.result.Text = "";
			// 
			// Dialer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 270);
			this.Controls.Add(this.result);
			this.Controls.Add(this.lblNumber);
			this.Controls.Add(this.number);
			this.Controls.Add(this.btnDisconnect);
			this.Controls.Add(this.btnConnect);
			this.Name = "Dialer";
			this.Text = "Dialer";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Dialer());
		}

		protected void myPhoner_OnChangeState(int CallID)
		{
			try
			{
				if( CallID == 0)
					return;

				Phoner.TCallState status;
				Phoner.TDirection direction;
				string callerID = "";
				string calledID = "";

				if(myPhoner.GetCallInfo(CallID, out status, out direction, out callerID, out calledID) != 0)
				{
					CurrCallID = CallID;
					StringBuilder sb = new StringBuilder();
					switch (status)
					{
						case Phoner.TCallState.Idle:
							sb.Append("Idle");
							break;
						case Phoner.TCallState.Offering:
							sb.Append("Offering");
							break;
						case Phoner.TCallState.Connecting:
							sb.Append("Connecting");
							break;
						case Phoner.TCallState.Connected:
							sb.Append("Connected");
							break;
						case Phoner.TCallState.Disconnected:
							sb.Append("Disconnected");
							this.btnConnect.Enabled = true;
							break;
						case Phoner.TCallState.Disconnecting:
							sb.Append("Disconnecting");
							break;
						case Phoner.TCallState.Conferenced:
							sb.Append("Conferenced");
							break;
						case Phoner.TCallState.Hold:
							sb.Append("Hold");
							break;
						case Phoner.TCallState.Holding:
							sb.Append("Holding");
							break;
						case Phoner.TCallState.Unholding:
							sb.Append("Unholding");
							break;
						case Phoner.TCallState.Parked:
							sb.Append("Parked");
							break;
						default:
					}
				
					sb.Append("\t");
				
					switch (direction)
					{
						case Phoner.TDirection.Incoming:
							sb.Append("Incoming");
							break;
						case Phoner.TDirection.Outgoing:
							sb.Append("Outgoing");
							break;
						default:
					}

					sb.Append("\t");
					if(callerID != null)
					{
						sb.Append(callerID.ToString());
					}
					sb.Append("\t");
					if(calledID != null)
					{
						sb.Append(calledID.ToString());
					}
					sb.Append( "\t" + myPhoner.get_DisconnectReason(CallID));
					sb.Append("\r\n");
				
					this.result.AppendText(sb.ToString());
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error in myPhoner_OnChangeState \r\n " + ex.Message + "\r\n" + ex.StackTrace);
			}
		}

		private void btnConnect_Click(object sender, System.EventArgs e)
		{
			try 
			{
				this.result.Clear();

				string number = this.number.Text.ToString();

				if(number =="")
					myPhoner.MakeCall("");
				else
					myPhoner.MakeCall(number);

				this.btnDisconnect.Enabled = true;
				this.btnConnect.Enabled = false;

			}
			catch (Exception ex )
			{
				MessageBox.Show("Error in btnConnect_Click \r\n " + ex.Message + "\r\n" + ex.StackTrace);
			}
		}

		private void btnDisconnect_Click(object sender, System.EventArgs e)
		{
			try 
			{
				if(AcceptID !=0)
					myPhoner.DisconnectCall(AcceptID);
				else
					myPhoner.DisconnectCall(CurrCallID);
				this.btnDisconnect.Enabled = false;
				this.btnConnect.Enabled = true;
			}
			catch (Exception ex )
			{
				MessageBox.Show("Error in btnDisconnect_Click \r\n " + ex.Message + "\r\n" + ex.StackTrace);
			}
		}
	}
}